unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RXCtrls, Animate, ImgList, ExtCtrls, StdCtrls, Math, Menus,
  Placemnt;

  const
    kolvo=4;
    run=10;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    AnimatedImage1: TAnimatedImage;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Pfyjdj1: TMenuItem;
    N3: TMenuItem;
    FormPlacement1: TFormPlacement;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mm(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure bk(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Pfyjdj1Click(Sender: TObject);
  private
    { Private declarations }
  public
  pathM: string;
  global_X:integer;
  global_Y:integer;

  pos_x, pos_y: integer;
  AI: array [0..kolvo] of TAnimatedImage;
  px: array [0..kolvo] of integer;
  py: array [0..kolvo] of integer;

    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i: integer;
begin

for i:=0 to kolvo do begin
  //LEFT
  AI[i].Left:=AI[i].Left+px[i];
  //TOP
  AI[i].Top:=AI[i].Top+py[i];


  if AI[i].Left>self.Width-AI[i].Width-10  then begin
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p2.bmp');
   px[i]:=-1;
  end;
  if AI[i].Left<10 then begin
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p3.bmp');
   px[i]:=1;
  end;

  if AI[i].Top>self.Height-AI[i].Height-40 then begin
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p1.bmp');
   py[i]:=-1;
  end;
  if AI[i].Top<10 then begin
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p4.bmp');
   py[i]:=1;
  end;

//  application.ProcessMessages;
end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  pathM:=ExtractFilepath(application.ExeName);
  pos_x:=1; pos_y:=1;

  for i:=0 to kolvo do begin
    px[i]:=1; py[i]:=1;
  end;

  AI[0]:=form1.AnimatedImage1;
  AI[0].OnMouseMove := form1.mm;
  AI[0].OnClick := form1.bk;
  for i:=1 to kolvo do begin
    AI[i]:=TAnimatedImage.Create(self);
    AI[i].Parent := self;
    AI[i].Width := 61;
    AI[i].Height := 44;
    AI[i].Top := RandomRange(0,self.Height-AI[i].Height-10);
    AI[i].Left := RandomRange(0,self.Width-AI[i].Width-10);
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p2.bmp');
    AI[i].Visible := true;
    AI[i].OnMouseMove := form1.mm;
    AI[i].OnClick := form1.bk;
  end;

end;

procedure Tform1.bk(Sender: TObject);
var
  i,n: integer;
begin
for i:=0 to kolvo do begin
  if Sender = AI[i] then begin
    //  showmessage('!');
    px[i]:=0;
    py[i]:=0;
    AI[i].Glyph.LoadFromFile(pathM+'bmp\p4.bmp');
    AI[i].OnMouseMove := nil;
  end;
end;
end;

procedure Tform1.mm(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  i,n: integer;
begin
for i:=0 to kolvo do
  if Sender = AI[i] then n:=i;

  //LEFT
  if AI[n].Left>=global_X then begin
       px[n]:=run;
  end;
  if AI[n].Left+AI[n].Width<=global_X then begin
       px[n]:=-run;
  end;

  //TOP
  if AI[n].Top>=global_Y then begin
       py[n]:=run;
  end;
  if AI[n].Top+AI[n].Height<=global_Y then begin
       py[n]:=-run;
  end;

//  application.ProcessMessages;
//-----------
end;


procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  global_X:=X;
  global_Y:=Y;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  messagebox(form1.Handle,PChar(' .'+#13+'VVSite 2009'),' ',MB_OK+MB_ICONINFORMATION);
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  application.Terminate;
end;

procedure TForm1.Pfyjdj1Click(Sender: TObject);
var
  i: integer;
begin
  pos_x:=1; pos_y:=1;

  for i:=0 to kolvo do begin
    px[i]:=run; py[i]:=run;
    AI[i].OnMouseMove := form1.mm;
    AI[i].OnClick := form1.bk;
  end;

end;

end.
